
#include "stdafx.h"

#include "element_2_string.h"

void e2s(std::wostream & wss, element e)
{
   if (e.is_combinator())
   {
      unsigned t = e.as_combinator();
      switch (t)
      {
      case 0:
         wss << L"I";
         break;
      case 1:
         wss << L"K";
         break;
      case 2:
         wss << L"S";
         break;
      default:
         wss << L"c" << t;
         break;
      }
   }
   else if (e.is_argument())
      wss << L"a" << e.as_argument();
   else if (e.is_ref())
      wss << L"(ref)";
   else
      assert(false);
}

void el2c(std::wostream & wss, element_list const & el)
{
   element_list::const_reverse_iterator i = el.rbegin();
   if (i == el.rend())
      throw std::logic_error("empty element_list");

   for (;;)
   {
      e2s(wss, *i);
      ++i;
      if (i == el.rend())
         break;
      wss << L" ";
   }
}

void e2s_rec(std::wostream & wss, element e)
{
   if (e.is_combinator())
   {
      unsigned t = e.as_combinator();
      switch (t)
      {
      case 0:
         wss << L"I";
         break;
      case 1:
         wss << L"K";
         break;
      case 2:
         wss << L"S";
         break;
      default:
         wss << L"c" << t;
         break;
      }
   }
   else if (e.is_argument())
      wss << L"a" << e.as_argument();
   else if (e.is_ref())
   {
      wss << L"(";
      el2s_rec(wss, *e.as_ref());
      wss << L")";
   }
   else
      assert(false);
}

void el2s_rec(std::wostream & wss, element_list const & el)
{
   element_list::const_reverse_iterator i = el.rbegin();
   if (i == el.rend())
      throw std::logic_error("empty element_list");

   for (;;)
   {
      e2s_rec(wss, *i);
      ++i;
      if (i == el.rend())
         break;
      wss << L" ";
   }
}
